//+------------------------------------------------------------------+
//|                                              Trade Functions.mqh |
//|                                         Copyright 2018, Odera FX |
//|                                              chidera67@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, Odera FX"
#property link      "chidera67@gmail.com"
#property strict
enum ENUM_LotType
            { Fixed, //Fixed Lot
              PercentLot //Use Percent of Balance
            };
//+------------------------------------------------------------------+
//| defines                                                          |
//+------------------------------------------------------------------+
// #define MacrosHello   "Hello, world!"
// #define MacrosYear    2010
//+------------------------------------------------------------------+
//| DLL imports                                                      |
//+------------------------------------------------------------------+
// #import "user32.dll"
//   int      SendMessageA(int hWnd,int Msg,int wParam,int lParam);
// #import "my_expert.dll"
//   int      ExpertRecalculate(int wParam,int lParam);
// #import
//+------------------------------------------------------------------+
//| EX5 imports                                                      |
//+------------------------------------------------------------------+
// #import "stdlib.ex5"
//   string ErrorDescription(int error_code);
// #import
//+------------------------------------------------------------------+
//--- introduce the predefined variables from MQL4 for versatility of the code
#ifdef __MQL5__ 
#define Ask    SymbolInfoDouble(_Symbol,SYMBOL_ASK)
#define Bid    SymbolInfoDouble(_Symbol,SYMBOL_BID)
#endif 
//--- redefine the order types from MQL5 to MQL4 for versatility of the code
#ifdef __MQL4__ 
#define ORDER_TYPE_BUY        OP_BUY
#define ORDER_TYPE_SELL       OP_SELL
#define ORDER_TYPE_BUY_LIMIT  OP_BUYLIMIT
#define ORDER_TYPE_SELL_LIMIT OP_SELLLIMIT
#define ORDER_TYPE_BUY_STOP   OP_BUYSTOP
#define ORDER_TYPE_SELL_STOP  OP_SELLSTOP
#endif 

#property strict
//--- spread
//double spread;
//+------------------------------------------------------------------+
//| Check the correctness of StopLoss and TakeProfit                 |
//+------------------------------------------------------------------+

class Trade
  {private: ENUM_LotType LotStyle;
            void TradeAllowed(int &Error);
            int MagicNumber;
            int MaxSlippage;
            int SymbolType(string symbol="NULL", bool verbose=false);
            int OpenOrder(int ordertype, double price, double sl, double tp, double volume,string comment,string symbol = NULL);
            bool OrderModifyCheck(int ticket, double price, double sl, double tp);
            bool BrokerECN();
            bool CheckMoney(string symb, int type, double lots);
            bool Fun_Error(int Error);
            //double RiskPercent;
            //double FixedLots;
            double RiskPercent;
            double FixedLots;
            
            double LotSize(double EquityAtRisk,double OpenPrice,double StopLossPrice,int CurrentOrderType,string symbol="NULL",bool ReturnNormalizedLots=false,bool verbose=false);
            string CounterPairForCross(string symbol="NULL", bool verbose=false);
            bool CheckStopLoss_Takeprofit(ENUM_ORDER_TYPE type,double price,double sl,double TP);
           
public:
                     Trade(int magicnumber, int maxslippage, ENUM_LotType lotstyle = 0,double fixedlots = 1,double riskpercent = 0.1) 
                      {MagicNumber = magicnumber;
                       MaxSlippage = maxslippage;
                       LotStyle = lotstyle;
                       RiskPercent = riskpercent;
                       FixedLots = fixedlots;
                      }
                    ~Trade(void){};
                void CloseAllSymbolEATrades(string reason); //Close all trades placed by the EA
                void CloseTrades(int type, string reason);
                void CloseTrades(int type, string reason, int exemption);
                void TrailStop(string symbol, double trailstep);
                void TrailStop(string symbol,double trailstop, double trailstep);
                void DeletePendingOrders();
                 int GetOrderCount();
                 int GetOrderCount(int &buy, int &sell, string symbol = NULL);
                 int EnterMarketOrder(int ordertype, double price, double sl, double tp, double volume,string comment,string symbol = NULL);
                 int GetAllOrderCount(); //Includes both pending and active orders
                 int GetPendingOrderCount();
                 int GetMostRecentClosedTicket();
                 int GetMaxTicket();
                bool CloseOrder(int ticket,double lots,double closeprice,string reason);
                bool ClosePartPosition(int ticket,int percent,double closeprice, string reason);
                bool ModifyOrder(int ticket,double price,double sl,double tp);
                bool OrderSelectbyTicket(int orderticket);
                bool IsNewBar();
                double PipsToPoints(double pips,bool fourthdecimal = false);
                double LotGen(int ordertype, double StopLossPrice, double pendingprice = 0);
                double NormalizeLotSize(double CurrentLotSize, string symbol="NULL", bool verbose=false);
                double ProfitPerPoint(bool verbose = false);
  };

bool Trade::IsNewBar(void)
{static datetime lastTime = 0;
 if (lastTime == 0)
 {lastTime = Time[0];
  return false;
 }
 else if (lastTime != Time[0])
 {lastTime = Time[0];
  return true;
 }
 return false;
}

double Trade::ProfitPerPoint(bool verbose = false)
{string usd = AccountCurrency(); 
 int pos = StringFind(_Symbol,usd);
 if (pos >= 3) //usd is listed second
 {if (verbose)Print("Account Currency listed second"); 
  return NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_TRADE_CONTRACT_SIZE) * _Point,2);
 }
 else if (pos < 3 && pos >-1) //USD is listed first
 {double ppp = SymbolInfoDouble(_Symbol,SYMBOL_TRADE_CONTRACT_SIZE) * _Point;
  if (verbose)Print("Account currency is listed first");
  ppp/= Bid;
  return NormalizeDouble(ppp,2);
  //if (StringFind(_Symbol,"JPY",pos+3) > -1) ppp*= 10;
 }
 else if (pos <0)    //USD is not listed
 {string base = StringSubstr(_Symbol,0,3), counter_currency = StringSubstr(_Symbol,3,6), postfix = StringSubstr(_Symbol,6);
  if (verbose)Print("This symbol is a cross");
  double fixed_value = SymbolInfoDouble(_Symbol,SYMBOL_TRADE_CONTRACT_SIZE) * _Point;
  if (MarketInfo(StringConcatenate(usd,counter_currency,postfix),MODE_LOTSIZE) > 0)
  {double ppp = fixed_value/MarketInfo(StringConcatenate(usd,counter_currency,postfix),MODE_BID);
   return NormalizeDouble(ppp,2);
  }
  else if (MarketInfo(StringConcatenate(counter_currency,usd,postfix),MODE_LOTSIZE) > 0)
  {double bid = 1/MarketInfo(StringConcatenate(counter_currency,usd,postfix),MODE_BID);
   double ppp = fixed_value/bid;
   return NormalizeDouble(ppp,2);
  }
  else 
  {Print("Could not calculate Profit Per Point for current symbol");
   return -1;
  }
 }
 Print("Could not calculate Profit Per Point for current symbol");
 return -1;
}
bool Trade::CheckStopLoss_Takeprofit(ENUM_ORDER_TYPE type,double price,double sl,double tp)
  {   double spread=Ask-Bid;
//--- get the SYMBOL_TRADE_STOPS_LEVEL level
   int stops_level=(int)SymbolInfoInteger(_Symbol,SYMBOL_TRADE_STOPS_LEVEL);
   if(stops_level!=0)
     {
      PrintFormat("SYMBOL_TRADE_STOPS_LEVEL=%d: StopLoss and TakeProfit must"+
                  " not be nearer than %d points from the closing price",stops_level,stops_level);
     }
//---
   bool SL_check=false,TP_check=false;
//--- check the order type
   switch(type)
     {
      //--- Buy operation
      case  ORDER_TYPE_BUY:
        {
         //--- check the StopLoss
         SL_check=(Bid-sl>stops_level*_Point);
         if (sl == 0) SL_check = true;
         if(!SL_check && sl != 0)
            PrintFormat("For order %s   StopLoss=%.5f must be less than %.5f"+
                        " (Bid=%.5f - SYMBOL_TRADE_STOPS_LEVEL=%d points)",
                        EnumToString(type),sl,Bid-stops_level*_Point,Bid,stops_level);
         //--- check the TakeProfit
         TP_check=(tp-Bid>stops_level*_Point);
         if (tp == 0)TP_check = true;
         if(!TP_check && tp!= 0)
            PrintFormat("For order %s   TakeProfit=%.5f must be greater than %.5f"+
                        " (Bid=%.5f + SYMBOL_TRADE_STOPS_LEVEL=%d points)",
                        EnumToString(type),tp,Bid+stops_level*_Point,Bid,stops_level);
         //--- return the result of checking
         return(SL_check&&TP_check);
        }
      //--- Sell operation
      case  ORDER_TYPE_SELL:
        {
         //--- check the StopLoss
         SL_check=(sl-Ask>stops_level*_Point);
         if (sl == 0) SL_check = true;
         if(!SL_check)
            PrintFormat("For order %s   StopLoss=%.5f must be greater than %.5f"+
                        " (Ask=%.5f + SYMBOL_TRADE_STOPS_LEVEL=%d points)",
                        EnumToString(type),sl,Ask+stops_level*_Point,Ask,stops_level);
         //--- check the TakeProfit
         TP_check=(Ask-tp>stops_level*_Point);
         if (tp == 0) TP_check = true;
         if(!TP_check)
            PrintFormat("For order %s   TakeProfit=%.5f must be less than %.5f"+
                        " (Ask=%.5f - SYMBOL_TRADE_STOPS_LEVEL=%d points)",
                        EnumToString(type),tp,Ask-stops_level*_Point,Ask,stops_level);
         //--- return the result of checking
         return(TP_check&&SL_check);
        }
      break;
      //--- BuyLimit pending order
      case  ORDER_TYPE_BUY_LIMIT:
        {
         //--- check the StopLoss
         SL_check=((price-sl)>stops_level*_Point);
         if (sl == 0) SL_check = true;
         if(!SL_check)
            PrintFormat("For order %s   StopLoss=%.5f must be less than %.5f"+
                        " (Open-StopLoss=%d points ==> SYMBOL_TRADE_STOPS_LEVEL=%d points)",
                        EnumToString(type),sl,price-stops_level*_Point,(int)((price-sl)/_Point),stops_level);
         //--- check the TakeProfit
         TP_check=((tp-price)>stops_level*_Point);
         if (tp == 0) TP_check = true;
         if(!TP_check)
            PrintFormat("For order %s   TakeProfit=%.5f must be greater than %.5f"+
                        " (TakeProfit-Open=%d points ==> SYMBOL_TRADE_STOPS_LEVEL=%d points)",
                        EnumToString(type),tp,price+stops_level*_Point,(int)((tp-price)/_Point),stops_level);
         //--- return the result of checking
         return(SL_check&&TP_check);
        }
      //--- SellLimit pending order
      case  ORDER_TYPE_SELL_LIMIT:
        {
         //--- check the StopLoss
         SL_check=((sl-price)>stops_level*_Point);
         if (sl == 0) SL_check = true;
         if(!SL_check)
            PrintFormat("For order %s   StopLoss=%.5f must be greater than %.5f"+
                        " (StopLoss-Open=%d points ==> SYMBOL_TRADE_STOPS_LEVEL=%d points)",
                        EnumToString(type),sl,price+stops_level*_Point,(int)((sl-price)/_Point),stops_level);
         //--- check the TakeProfit
         TP_check=((price-tp)>stops_level*_Point);
         if (tp == 0) TP_check = true;
         if(!TP_check)
            PrintFormat("For order %s   TakeProfit=%.5f must be less than %.5f"+
                        " (Open-TakeProfit=%d points ==> SYMBOL_TRADE_STOPS_LEVEL=%d points)",
                        EnumToString(type),tp,price-stops_level*_Point,(int)((price-tp)/_Point),stops_level);
         //--- return the result of checking
         return(TP_check&&SL_check);
        }
      break;
      //--- BuyStop pending order
      case  ORDER_TYPE_BUY_STOP:
        {
         //--- check the StopLoss
         SL_check=((price-sl)>stops_level*_Point);
         if (sl == 0) SL_check = true;
         if(!SL_check)
            PrintFormat("For order %s   StopLoss=%.5f must be less than %.5f"+
                        " (Open-StopLoss=%d points ==> SYMBOL_TRADE_STOPS_LEVEL=%d points)",
                        EnumToString(type),sl,price-stops_level*_Point,(int)((price-sl)/_Point),stops_level);
         //--- check the TakeProfit
         TP_check=((tp-price)>stops_level*_Point);
         if (tp == 0) TP_check = true;
         if(!TP_check)
            PrintFormat("For order %s   TakeProfit=%.5f must be greater than %.5f"+
                        " (TakeProfit-Open=%d points ==> SYMBOL_TRADE_STOPS_LEVEL=%d points)",
                        EnumToString(type),tp,price-stops_level*_Point,(int)((tp-price)/_Point),stops_level);
         //--- return the result of checking
         return(SL_check&&TP_check);
        }
      //--- SellStop pending order
      case  ORDER_TYPE_SELL_STOP:
        {
         //--- check the StopLoss
         SL_check=((sl-price)>stops_level*_Point);
         if (sl == 0) SL_check = true;
         if(!SL_check)
            PrintFormat("For order %s   StopLoss=%.5f must be greater than %.5f"+
                        " (StopLoss-Open=%d points ==> SYMBOL_TRADE_STOPS_LEVEL=%d points)",
                        EnumToString(type),sl,price+stops_level*_Point,(int)((sl-price)/_Point),stops_level);
         //--- check the TakeProfit
         TP_check=((price-tp)>stops_level*_Point);
         if (tp == 0) TP_check = true;
         if(!TP_check)
            PrintFormat("For order %s   TakeProfit=%.5f must be less than %.5f"+
                        " (Open-TakeProfit=%d points ==> SYMBOL_TRADE_STOPS_LEVEL=%d points)",
                        EnumToString(type),tp,price-stops_level*_Point,(int)((price-tp)/_Point),stops_level);
         //--- return the result of checking
         return(TP_check&&SL_check);
        }
      break;
     }

//---
   return false;
  }
int Trade::GetMostRecentClosedTicket(void)
{int histotal = OrdersHistoryTotal();
 int max = 0;
 for(int i=histotal-1;i>=0;i--)
   {if (OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
    {if (OrderMagicNumber() == MagicNumber && OrderSymbol() == _Symbol)
     {if (OrderTicket() > max) max = OrderTicket();
     }
    }
   }
return(max);
}
int Trade::GetMaxTicket(void)
{int ordtotal = OrdersTotal();
 int max = 0;
 for(int i=ordtotal-1;i>=0;i--)
   {if (OrderSelect(i,SELECT_BY_POS))
    {if (OrderMagicNumber() == MagicNumber && OrderSymbol() == _Symbol)
     {if (OrderTicket() > max) max = OrderTicket();
     }
    }
   }
return(max);
}
void Trade::DeletePendingOrders(void)
{int ordtotal = OrdersTotal();
 for(int i=ordtotal-1;i>=0;i--)
   {if (OrderSelect(i,SELECT_BY_POS))
    {if (OrderMagicNumber() == MagicNumber && OrderType() > OP_SELL && OrderSymbol() == _Symbol )
     {bool res = OrderDelete(OrderTicket());
     }
    }
    
   }
}
void Trade::TrailStop(string symbol,double trailstep)
{double trailpips = PipsToPoints(trailstep);
 int ordtotal = OrdersTotal();
 for(int i = ordtotal -1; i>=0; i--)
 {if (OrderSelect(i,SELECT_BY_POS))
  {if (OrderMagicNumber() != MagicNumber)  continue;
   if (OrderSymbol() != symbol) continue;
//----------------
   int type = OrderType();
   if (type == OP_BUY)
   {double sl = OrderStopLoss();
    if (Bid - sl > trailpips + _Point) 
    {double newsl = Bid - trailpips;
     double tp = OrderTakeProfit();
     ModifyOrder(OrderTicket(),OrderOpenPrice(),newsl,tp);
    }
   }
//----------------
   else if (type == OP_SELL)
   {double sl = OrderStopLoss();
    if (fabs(sl - Ask) > trailpips + _Point) 
    {double newsl = Ask + trailpips;
     double tp = OrderTakeProfit();
     ModifyOrder(OrderTicket(),OrderOpenPrice(),newsl,tp);
    }
   }
//----------------
  }
 }
}
void Trade::TrailStop(string symbol,double trailstop, double trailstep)
{trailstep = PipsToPoints(trailstep,true); trailstop = PipsToPoints(trailstop,true);
 int ordtotal = OrdersTotal();
 for(int i = ordtotal -1; i>=0; i--)
 {if (OrderSelect(i,SELECT_BY_POS))
  {if (OrderMagicNumber() != MagicNumber)  continue;
   if (OrderSymbol() != symbol) continue;
//----------------
   int type = OrderType();
   if (type == OP_BUY)
   {double sl = OrderStopLoss();
    if (Bid - sl >= trailstep + trailstop) 
    {double newsl = Bid - trailstop;
     double tp = OrderTakeProfit();
     if (newsl > sl)
     ModifyOrder(OrderTicket(),OrderOpenPrice(),newsl,tp);
    }
   }
//----------------
   else if (type == OP_SELL)
   {double sl = OrderStopLoss();
    if (fabs(sl - Ask) >= trailstep + trailstop) 
    {double newsl = Ask + trailstop;
     double tp = OrderTakeProfit();
     if (newsl < sl)
     ModifyOrder(OrderTicket(),OrderOpenPrice(),newsl,tp);
    }
   }
//----------------
  }
 }
}

bool Trade::CheckMoney(string symb,int type,double lots)
{ double free_margin=AccountFreeMarginCheck(symb,type, lots);
   //-- if there is not enough money
   if(free_margin<0)
     {
      string oper=(type==OP_BUY)? "Buy":"Sell";
      Print("Not enough money for ", oper," ",lots, " ", symb, " Error code=",GetLastError());
      return(false);
     }
   //--- checking successful
   return(true);
 }
int Trade::EnterMarketOrder(int ordertype,double price,double sl,double tp,double volume,string comment,string symbol = NULL)
{int ticket = -1;
 if (symbol == NULL) symbol = _Symbol;
//------------------------------------------------------------
 if (BrokerECN() && ordertype < 2)
  {ticket = OpenOrder(ordertype,price,0,0,volume,comment,symbol);
   //Print("Broker ECN ",ordertype);
   if (ticket > 0)
   bool res = ModifyOrder(ticket,price,sl,tp);
  }
  else
  ticket = OpenOrder(ordertype,price,sl,tp,volume,comment,symbol);
  /*if(ticket > 0)
  {OrderSelectbyTicket(ticket);
   double slippage = fabs(price - OrderOpenPrice())/_Point;
   printf ("Slippage for Order with ticket %d = %g",ticket,slippage);
  }*/
//-------------------------------------------------------------
return (ticket);
}
double Trade::NormalizeLotSize(double CurrentLotSize, string symbol="NULL", bool verbose=false)
   {  // NormalizeLotSize body start
   double   CalculatedNormalizeLotSize=0.;
   int      LotSizeDigits=0;

   string   CurrentSymbol=symbol;
   if(symbol=="NULL") CurrentSymbol=Symbol();
      
   LotSizeDigits=(int)-MathRound(MathLog(MarketInfo(CurrentSymbol,MODE_LOTSTEP))/MathLog(10.)); // Number of digits after decimal point for the Lot for the current broker, like Digits for symbol prices
   
   CalculatedNormalizeLotSize=NormalizeDouble(MathFloor((CurrentLotSize-MarketInfo(CurrentSymbol,MODE_MINLOT))/MarketInfo(CurrentSymbol,MODE_LOTSTEP))*MarketInfo(CurrentSymbol,MODE_LOTSTEP)+MarketInfo(CurrentSymbol,MODE_MINLOT),LotSizeDigits);
   
   if(verbose==true) Print("The broker-normalized lotsize is ",DoubleToStr(CalculatedNormalizeLotSize,LotSizeDigits));
   
   return(CalculatedNormalizeLotSize);
   
   }  // NormalizeLotSize body end

// Program End

//------------------------------------------------
int Trade::SymbolType(string symbol="NULL", bool verbose=false)
   {  // SymbolType body start
   int   CalculatedSymbolType=6;
   string   SymbolBase="",SymbolCounter="",postfix="",CalculatedBasePairForCross="",CalculatedCounterPairForCross="";
   
   string   CurrentSymbol=symbol;
   if(symbol=="NULL") CurrentSymbol=Symbol();
   //Print("Account currency is ", AccountCurrency()," and Current Symbol = ",CurrentSymbol);
   if(verbose==true) Print("Account currency is ", AccountCurrency()," and Current Symbol = ",CurrentSymbol);
   
   SymbolBase=StringSubstr(CurrentSymbol,0,3);
   SymbolCounter=StringSubstr(CurrentSymbol,3,3);
   postfix=StringSubstr(CurrentSymbol,6);
   
   if(SymbolBase==AccountCurrency()) CalculatedSymbolType=1;
   if(SymbolCounter==AccountCurrency()) CalculatedSymbolType=2;
   
   if((CalculatedSymbolType==1 || CalculatedSymbolType==2) && verbose==true) Print("Base currency is ",SymbolBase," and the Counter currency is ",SymbolCounter," (this pair is a major)");

   if(CalculatedSymbolType!=1 && CalculatedSymbolType!=2)
      {
      if(verbose==true) Print("Base currency is ",SymbolBase," and the Counter currency is ",SymbolCounter," (this pair is a cross)");

      // Determine if AccountCurrency() is the COUNTER currency or the BASE currency for the COUNTER currency forming CurrentSymbol
      if(MarketInfo(StringConcatenate(AccountCurrency(),SymbolCounter,postfix),MODE_LOTSIZE)>0)
         {
         CalculatedSymbolType=4; // SymbolType can also be 3 but this will be determined later when the Base pair is identified
         CalculatedCounterPairForCross=StringConcatenate(AccountCurrency(),SymbolCounter,postfix);
         if(verbose==true) Print(AccountCurrency()," is the Base currency to the Counter currency for this cross, the CounterPair is ",CalculatedCounterPairForCross,", Bid = ",DoubleToStr(MarketInfo(CalculatedCounterPairForCross,MODE_BID),(int)MarketInfo(CalculatedCounterPairForCross,MODE_DIGITS))," and Ask = ",DoubleToStr(MarketInfo(CalculatedCounterPairForCross,MODE_ASK),(int)MarketInfo(CalculatedCounterPairForCross,MODE_DIGITS)));
         }
      else if(MarketInfo(StringConcatenate(SymbolCounter,AccountCurrency(),postfix),MODE_LOTSIZE)>0)
         {
         CalculatedSymbolType=5;
         CalculatedCounterPairForCross=StringConcatenate(SymbolCounter,AccountCurrency(),postfix);
         if(verbose==true) Print(AccountCurrency()," is the Counter currency to the Counter currency for this cross, the CounterPair is ",CalculatedCounterPairForCross,", Bid = ",DoubleToStr(MarketInfo(CalculatedCounterPairForCross,MODE_BID),(int)MarketInfo(CalculatedCounterPairForCross,MODE_DIGITS))," and Ask = ",DoubleToStr(MarketInfo(CalculatedCounterPairForCross,MODE_ASK),(int)MarketInfo(CalculatedCounterPairForCross,MODE_DIGITS)));
         }
      
      // Determine if AccountCurrency() is the COUNTER currency or the BASE currency for the BASE currency forming CurrentSymbol
      if(MarketInfo(StringConcatenate(AccountCurrency(),SymbolBase,postfix),MODE_LOTSIZE)>0)
         {
         CalculatedSymbolType=3;
         CalculatedBasePairForCross=StringConcatenate(AccountCurrency(),SymbolBase,postfix);
         if(verbose==true) Print(AccountCurrency()," is the Base currency to the Base currency for this cross, the BasePair is ",CalculatedBasePairForCross,", Bid = ",DoubleToStr(MarketInfo(CalculatedBasePairForCross,MODE_BID),(int)MarketInfo(CalculatedBasePairForCross,MODE_DIGITS))," and Ask = ",DoubleToStr(MarketInfo(CalculatedBasePairForCross,MODE_ASK),(int)MarketInfo(CalculatedBasePairForCross,MODE_DIGITS)));
         }
      else if(MarketInfo(StringConcatenate(SymbolBase,AccountCurrency(),postfix),MODE_LOTSIZE)>0)
         {
         CalculatedBasePairForCross=StringConcatenate(SymbolBase,AccountCurrency(),postfix);
         if(verbose==true) Print(AccountCurrency()," is the Counter currency to the Base currency for this cross, the BasePair is ",CalculatedBasePairForCross,", Bid = ",DoubleToStr(MarketInfo(CalculatedBasePairForCross,MODE_BID),(int)MarketInfo(CalculatedBasePairForCross,MODE_DIGITS))," and Ask = ",DoubleToStr(MarketInfo(CalculatedBasePairForCross,MODE_ASK),(int)MarketInfo(CalculatedBasePairForCross,MODE_DIGITS)));
         }
      }
   if(verbose==true) Print("SymbolType() = ",CalculatedSymbolType);
   
   if(CalculatedSymbolType==6) Print("Error occurred while identifying SymbolType(), calculated SymbolType() = ",CalculatedSymbolType);
   
   return(CalculatedSymbolType);
   }  // SymbolType body end

//-------------------------------------------------
string Trade::CounterPairForCross(string symbol="NULL", bool verbose=false)
   {  // CounterPairForCross body start
   string   SymbolBase="",SymbolCounter="",postfix="",CalculatedCounterPairForCross="";
   
   string   CurrentSymbol=symbol;
   if(symbol=="NULL") CurrentSymbol=Symbol();
   
   if(verbose==true) Print("Account currency is ", AccountCurrency()," and Current Symbol = ",CurrentSymbol);
   
   SymbolBase=StringSubstr(CurrentSymbol,0,3);
   SymbolCounter=StringSubstr(CurrentSymbol,3,3);
   postfix=StringSubstr(CurrentSymbol,6);
   
   switch(SymbolType(CurrentSymbol)) // Determine if AccountCurrency() is the COUNTER currency or the BASE currency for the COUNTER currency forming CurrentSymbol
      {
      case 1   :  break;
      case 2   :  break;
      case 3   :  CalculatedCounterPairForCross=StringConcatenate(AccountCurrency(),SymbolCounter,postfix);
                  if(verbose==true) Print(AccountCurrency()," is the Base currency to the Counter currency for this cross, the CounterPair is ",CalculatedCounterPairForCross,", Bid = ",DoubleToStr(MarketInfo(CalculatedCounterPairForCross,MODE_BID),(int)MarketInfo(CalculatedCounterPairForCross,MODE_DIGITS))," and Ask = ",DoubleToStr(MarketInfo(CalculatedCounterPairForCross,MODE_ASK),(int)MarketInfo(CalculatedCounterPairForCross,MODE_DIGITS))); break;
      case 4   :  CalculatedCounterPairForCross=StringConcatenate(AccountCurrency(),SymbolCounter,postfix);
                  if(verbose==true) Print(AccountCurrency()," is the Base currency to the Counter currency for this cross, the CounterPair is ",CalculatedCounterPairForCross,", Bid = ",DoubleToStr(MarketInfo(CalculatedCounterPairForCross,MODE_BID),(int)MarketInfo(CalculatedCounterPairForCross,MODE_DIGITS))," and Ask = ",DoubleToStr(MarketInfo(CalculatedCounterPairForCross,MODE_ASK),(int)MarketInfo(CalculatedCounterPairForCross,MODE_DIGITS))); break;
      case 5   :  CalculatedCounterPairForCross=StringConcatenate(SymbolCounter,AccountCurrency(),postfix);
                  if(verbose==true) Print(AccountCurrency()," is the Counter currency to the Counter currency for this cross, the CounterPair is ",CalculatedCounterPairForCross,", Bid = ",DoubleToStr(MarketInfo(CalculatedCounterPairForCross,MODE_BID),(int)MarketInfo(CalculatedCounterPairForCross,MODE_DIGITS))," and Ask = ",DoubleToStr(MarketInfo(CalculatedCounterPairForCross,MODE_ASK),(int)MarketInfo(CalculatedCounterPairForCross,MODE_DIGITS))); break;
      case 6   :  Print("Error occurred while identifying SymbolType(), calculated SymbolType() = 6"); break;
      default  :  Print("Error encountered in the SWITCH routine for identifying CounterPairForCross on financial instrument ",CurrentSymbol); // The expression did not generate a case value
      }
   
   return(CalculatedCounterPairForCross);
   
   }  // CounterPairForCross body end

//-------------------------------------------------
double Trade::LotSize(double EquityAtRisk,double OpenPrice,double StopLossPrice,int CurrentOrderType,string symbol="NULL",bool ReturnNormalizedLots=false,bool verbose=false)
   {  // LotSize body start
   string   CurrentSymbol=symbol;
   if(symbol=="NULL") CurrentSymbol=Symbol();
   
   int      CurrentSymbolType=SymbolType(CurrentSymbol);  //|      CurrentSymbolType -  The type of currency pair represented by CurrentSymbol.
            if(CurrentSymbolType==6)
               {
               Print("Internal Error in determination of SymbolType for currency pair ",CurrentSymbol,", exiting script without computing Lotsize");
               return(0);
               }
   string   CurrentCounterPairForCross=CounterPairForCross(CurrentSymbol);  //|      CurrentCounterPairForCross -  The name of the financial instrument which is the counter currency pair to CurrentSymbol (relevant to crosses)
   
   double   CalculatedLotSize=0.;
   
   // Constant     Value   Description 
   // OP_BUY         0     Buying position.
   // OP_SELL        1     Selling position.
   // OP_BUYLIMIT    2     Buy limit pending position.
   // OP_SELLLIMIT   3     Sell limit pending position.
   // OP_BUYSTOP     4     Buy stop pending position.
   // OP_SELLSTOP    5     Sell stop pending position.
   
   switch(CurrentSymbolType) // Determine the equity at risk based on the SymbolType for the financial instrument
      {
      case 1   :  switch(CurrentOrderType)   // Currency Pairs with USD as base - e.g. USDJPY
                     {
                     case OP_BUY       :  // Long position
                     case OP_BUYLIMIT  :  // Long position
                     case OP_BUYSTOP   :  CalculatedLotSize=(-EquityAtRisk*StopLossPrice)/(MarketInfo(CurrentSymbol,MODE_LOTSIZE)*(StopLossPrice-OpenPrice)); break;
                     case OP_SELL      :  // Short position
                     case OP_SELLLIMIT :  // Short position
                     case OP_SELLSTOP  :  CalculatedLotSize=(-EquityAtRisk*StopLossPrice)/(MarketInfo(CurrentSymbol,MODE_LOTSIZE)*(OpenPrice-StopLossPrice)); break;
                     default           :  Print("Error encountered in the OrderType switch for calculating the LotSize"); // The expression did not generate a case value
                     }
                  break;
      case 2   :  switch(CurrentOrderType)   // Currency Pairs with USD as counter - e.g. EURUSD
                     {
                     case OP_BUY       :  // Long position
                     case OP_BUYLIMIT  :  // Long position
                     case OP_BUYSTOP   :  CalculatedLotSize=-EquityAtRisk/(MarketInfo(CurrentSymbol,MODE_LOTSIZE)*(StopLossPrice-OpenPrice)); break;
                     case OP_SELL      :  // Short position
                     case OP_SELLLIMIT :  // Short position
                     case OP_SELLSTOP  :  CalculatedLotSize=-EquityAtRisk/(MarketInfo(CurrentSymbol,MODE_LOTSIZE)*(OpenPrice-StopLossPrice)); break;
                     default           :  Print("Error encountered in the OrderType switch for calculating the LotSize"); // The expression did not generate a case value
                     }
                  break;
      case 3   :  // e.g. Symbol() = CHFJPY, the counter currency is JPY and the USD is the base to the JPY in the pair USDJPY
                  // falls thru and is treated the same as SymbolType()==4 for the purpose of these calculations
      case 4   :  switch(CurrentOrderType)  // e.g. Symbol() = AUDCAD, the counter currency is CAD and the USD is the base to the CAD in the pair USDCAD
                     {
                     case OP_BUY       :  // Long position
                     case OP_BUYLIMIT  :  // Long position
                     case OP_BUYSTOP   :  CalculatedLotSize=(-EquityAtRisk*MarketInfo(CurrentCounterPairForCross,MODE_BID))/(MarketInfo(CurrentSymbol,MODE_LOTSIZE)*(StopLossPrice-OpenPrice)); break;
                     case OP_SELL      :  // Short position
                     case OP_SELLLIMIT :  // Short position
                     case OP_SELLSTOP  :  CalculatedLotSize=(-EquityAtRisk*MarketInfo(CurrentCounterPairForCross,MODE_ASK))/(MarketInfo(CurrentSymbol,MODE_LOTSIZE)*(OpenPrice-StopLossPrice)); break;
                     default           :  Print("Error encountered in the OrderType switch for calculating the LotSize"); // The expression did not generate a case value
                     }
                  break;
      case 5   :  switch(CurrentOrderType)  // e.g. Symbol() = EURGBP, the counter currency is GBP and the USD is the counter to the GBP in the pair GBPUSD
                     {
                     case OP_BUY       :  // Long position
                     case OP_BUYLIMIT  :  // Long position
                     case OP_BUYSTOP   :  CalculatedLotSize=-EquityAtRisk/(MarketInfo(CurrentSymbol,MODE_LOTSIZE)*MarketInfo(CurrentCounterPairForCross,MODE_BID)*(StopLossPrice-OpenPrice)); break;
                     case OP_SELL      :  // Short position
                     case OP_SELLLIMIT :  // Short position
                     case OP_SELLSTOP  :  CalculatedLotSize=-EquityAtRisk/(MarketInfo(CurrentSymbol,MODE_LOTSIZE)*MarketInfo(CurrentCounterPairForCross,MODE_ASK)*(OpenPrice-StopLossPrice)); break;
                     default           :  Print("Error encountered in the OrderType switch for calculating the LotSize"); // The expression did not generate a case value
                     }
                  break;
      default  :  Print("Error encountered in the CurrentSymbolType switch for calculating the LotSize"); // The expression did not generate a case value
      }
   
   if(CalculatedLotSize<0) CalculatedLotSize=0;
   
   if(ReturnNormalizedLots==true) CalculatedLotSize=NormalizeLotSize(CalculatedLotSize);
   
   if(verbose==true) Print("The calculated lot size is ",CalculatedLotSize);
   
   return(CalculatedLotSize);
   
   }  // LotSize body end

//int count = 0;
double Trade::LotGen(int ordertype, double StopLossPrice, double pendingprice = 0)
{if (LotStyle == PercentLot)
 { double MaxPercentEquityAtRisk = RiskPercent;
   double OpenPrice = 0;
   
   if (ordertype == OP_BUY) OpenPrice = Ask;
   else if (ordertype == OP_SELL) OpenPrice = Bid;
   else OpenPrice = pendingprice;
   
   string CurrentSymbol = _Symbol;
   double CurrentEquityAtRisk=(MaxPercentEquityAtRisk/100.)*AccountBalance();
   double CurrentLotSize=LotSize(CurrentEquityAtRisk,OpenPrice,StopLossPrice,ordertype); // Compute the max possible lotsize for the risk equity
   Print("Max allowed EquityAtRisk = $",DoubleToStr(CurrentEquityAtRisk,2)," and Max computed Lotsize = ",CurrentLotSize);
   CurrentLotSize=NormalizeLotSize(CurrentLotSize);   // Normalize the lotsize to conform with the Broker's specific quantized position allowances
   if(CurrentLotSize<MarketInfo(CurrentSymbol,MODE_MINLOT)) CurrentLotSize=MarketInfo(CurrentSymbol,MODE_MINLOT);
   if(CurrentLotSize>MarketInfo(CurrentSymbol,MODE_MAXLOT)) CurrentLotSize=MarketInfo(CurrentSymbol,MODE_MAXLOT);
   return(CurrentLotSize);
 }
 else if (LotStyle == Fixed) return(FixedLots);
 return-1;
}
//+------------------------------------------------------------------+

double Trade::PipsToPoints(double pips, bool fourthdecimal = false)
  {if (fourthdecimal)
   {string symbol = _Symbol;
//------------------------------------------------------------------
   if(MarketInfo(symbol,MODE_DIGITS)==5 || MarketInfo(symbol,MODE_DIGITS)==3) pips*=10;
   }
   pips *= _Point;
   return (pips);
//------------------------------------------------------------------
  }
int Trade::GetPendingOrderCount()
  {
   int activeTrades=0;
   for(int i=OrdersTotal()-1; i>=0; i--)
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         if(OrderMagicNumber() == MagicNumber && (OrderType() == OP_SELLLIMIT || OrderType() == OP_BUYLIMIT 
         || OrderType() == OP_SELLSTOP || OrderType() == OP_BUYSTOP) && OrderSymbol() == Symbol())
            activeTrades++;
   return (activeTrades);
  }
int Trade::GetAllOrderCount()
  {
   int activeTrades=0;
   for(int i=OrdersTotal()-1; i>=0; i--)
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         if(OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol())
            activeTrades++;
   return (activeTrades);
  }

int Trade::GetOrderCount()
  {
   int activeTrades=0;
   for(int i=OrdersTotal()-1; i>=0; i--)
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         if(OrderMagicNumber() == MagicNumber && (OrderType() == OP_SELL || OrderType() == OP_BUY) && OrderSymbol() == Symbol())
            activeTrades++;
   return (activeTrades);
  }
int Trade::GetOrderCount(int &buy, int &sell, string symbol = NULL)
  {buy = 0;
   sell = 0;
   int activeTrades=0;
   
   if (symbol == NULL) symbol = _Symbol;
   
   for(int i=OrdersTotal()-1; i>=0; i--)
   {if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
     {if(OrderMagicNumber() == MagicNumber && (OrderType() == OP_SELL || OrderType() == OP_BUY) && OrderSymbol() == symbol)
      {if (OrderType() == OP_BUY) buy++;
       else if (OrderType() == OP_SELL) sell++;
       activeTrades++;
      }
     }
   }
   return (activeTrades);
  }
bool Trade::OrderModifyCheck(int ticket,double price,double sl,double tp) 
  {
//--- select order by ticket
   if(OrderSelect(ticket,SELECT_BY_TICKET))
     {
      //--- point size and name of the symbol, for which a pending order was placed
      string symbol=OrderSymbol();
      double point=SymbolInfoDouble(symbol,SYMBOL_POINT);
      //--- check if there are changes in the Open price
      bool PriceOpenChanged=false;
      int type=OrderType();
      if(type!=OP_BUY && type!=OP_SELL)
        {
         PriceOpenChanged=(MathAbs(OrderOpenPrice()-price)>point);
        }
      //--- check if there are changes in the StopLoss level
      bool StopLossChanged=(OrderStopLoss() != sl)?true:false;
      //--- check if there are changes in the Takeprofit level
      bool TakeProfitChanged=(OrderTakeProfit() != tp)? true: false;
      ENUM_ORDER_TYPE Type = -1;
      if (OrderType() == OP_BUY)
      type = ORDER_TYPE_BUY;
      if (OrderType() == OP_SELL)
      type = ORDER_TYPE_SELL;
      //--- if there are any changes in levels
      if(PriceOpenChanged || StopLossChanged || TakeProfitChanged)
         return(true);  // order can be modified      
      //--- there are no changes in the Open, StopLoss and Takeprofit levels
      else
      //--- notify about the error
         PrintFormat("Order #%d already has levels of Open=%.5f SL=%.5f TP=%.5f",
                     ticket,OrderOpenPrice(),OrderStopLoss(),OrderTakeProfit());
      
     }
//--- came to the end, no changes for the order
   return(false);       // no point in modifying 
  }
bool Trade::ClosePartPosition(int ticket,int percent,double closeprice, string reason)
{bool sel = OrderSelect(ticket,SELECT_BY_TICKET);
 if (sel)
 {double closevolume = (OrderLots() * percent)/100;
  closevolume = NormalizeDouble(closevolume,2);
  double minlot = 0.01;
  if (closevolume < minlot) closevolume = minlot;
  if (CloseOrder(ticket,closevolume,closeprice,reason)) return true;
 }
 return false;
}
bool Trade::CloseOrder(int ticket,double lots,double closePrice,string reason)
{int Error = 0; 
 TradeAllowed(Error); if(Error>0) return(false);
 if (!OrderSelectbyTicket(ticket)) return false;
 bool res = false;
 if (lots == 0 || closePrice == 0)
 {
  lots = OrderLots();
  closePrice = OrderClosePrice();
 }
 if (OrderCloseTime() == 0)
 res = OrderClose(ticket,lots,closePrice,MaxSlippage);
 if (res)
 {Print (ticket," has been closed by EA because ",reason);
  //string message = _Symbol+" Order Closed because "+reason;
  //SendNotification(message);
  //Alert(message);
  //PlaySound("alert2.wav");
  //SendMail("Trade Alert",message);
  //Print(message);
 }
 return (res);
}
//-----------------------
bool Trade::OrderSelectbyTicket(int orderticket)
  {
   int ticket=orderticket;
   if(ticket<=0) return(false);
   bool i2 = OrderSelect(orderticket,SELECT_BY_TICKET);
   return(i2);
  }

//+--------------------------------------------------------------------+
//|Order Modify                                                        |
//+--------------------------------------------------------------------+
bool Trade::ModifyOrder(int ticket,double price,double sl,double tp)
{ if (OrderModifyCheck(ticket,price,sl,tp) == false) 
   {//string reason = "Order Closed because of invalid SL or TP levels";
    //CloseOrder(ticket,0,0,reason);
    return(false);
   }
   int Error = 0;
   TradeAllowed(Error); if(Error>0) return(false);
   bool mod=false;
   while(mod==false)
     {
      mod=OrderModify(ticket,price,sl,tp,0);
      Error=GetLastError();
      if(Fun_Error(Error)) continue;
      else
         break;
     }

   return(mod);
  }
bool Trade::Fun_Error(int Error) // Function of processing errors
  {
   switch(Error)
     {                                          // Not crucial errors            
      case  4: Print("Trade server is busy. Trying once again..");
      Sleep(3000);                           // Simple solution
      return(true);                             // Exit the function
      case 6: Print("No connection to trade server. Trying once again...");
      RefreshRates();
      return (true);
      case 129: Print("Invalid price! Trying once again with updated price.");
      RefreshRates();
      return (true);
      case 145: Print("Modification is denied because order is too close to market");
      return(false);
      case 132: Print("Market Is Closed");
      return(false);
      case 135:Print("Price changed. Trying once again..");
      RefreshRates();                        // Refresh rates
      return(true);                             // Exit the function
      case 136:Print("No prices. Waiting for a new tick..");
      while(RefreshRates()==false) // Till a new tick
         Sleep(10);                           // Pause in the loop
      return(true);                             // Exit the function
      case 137:Print("Broker is busy. Trying once again..");
      Sleep(30);                           // Simple solution
      return(true);                             // Exit the function
      case 146:Print("Trading subsystem is busy. Trying once again..");
      Sleep(500);                            // Simple solution
      return(true);                             // Exit the function
                                                // Critical errors
      case  2: Print("Common error.");
      return(false);                             // Exit the function
      case  5: Print("Old terminal version.");
      return(false);                             // Exit the function
      case 64: Print("Account blocked.");
      return(false);                             // Exit the function
      case 133:Print("Trading forbidden.");
      return(false);                             // Exit the function
      case 134:Print("Not enough money to execute operation.");
      return(false);                             // Exit the function
      default:if(Error!=0) Print("Error occurred: ",Error);  // Other variants   
      return(false);                             // Exit the function
     }                                             //End of switch function
  }                                             //End of Fun error
//+------------------------------------------------------------------+
//|Check if trade is allowed                                         |
//+------------------------------------------------------------------+
void Trade::TradeAllowed(int &Error)
  {string comm_sys;
   ResetLastError();
   Error=0;
   if(!IsTesting())
     {
      if(!IsConnected())
        {
         comm_sys="No connection.";Print(comm_sys);Comment(comm_sys);
         while(!IsConnected())
           {
            if(IsStopped()) {Error=4;Print("Forced shutdown.");break;}
            Sleep(500);
            RefreshRates();
           }
         comm_sys="Is connected";Print(comm_sys);Comment(comm_sys);
        }

      if(!AccountInfoInteger(ACCOUNT_TRADE_EXPERT))
        {comm_sys="Automated trading is forbidden at the trade server side.";Print(comm_sys);Error=133;return;}
      if(!AccountInfoInteger(ACCOUNT_TRADE_ALLOWED))
        {comm_sys="Trading is forbidden!";Print(comm_sys);Error=64;return;}
      if(!TerminalInfoInteger(TERMINAL_TRADE_ALLOWED))
        {comm_sys="Check if automated trading is allowed in the terminal settings!";Print(comm_sys);Error=4109;return;}
      if(!IsTradeAllowed(_Symbol,TimeCurrent()))
        {Error=132; comm_sys="Trading on the symbol "+_Symbol+" is forbidden!";Print(comm_sys);return;}

      if(IsTradeContextBusy())
        {
         comm_sys="Trading is occupied. Wait.";Print(comm_sys);Comment(comm_sys);
         while(IsTradeContextBusy())
           {
            if(IsStopped()) {Error=4;Print("Forced shutdown.");break;}
            Sleep(200);
            RefreshRates();
           }
        }

      //  if(AccountLeverage()<=minimum_leverage_level && use_minimum_leverage==yes){Error=4500; comm_sys="Leverage too low!";return;}
     }
  }
//---------------------------
bool Trade::BrokerECN()
{bool broker_ecn=(SymbolInfoInteger(_Symbol,SYMBOL_TRADE_EXEMODE)==SYMBOL_TRADE_EXECUTION_MARKET);
 return broker_ecn;
}
int Trade::OpenOrder(int ordertype, double price, double sl, double tp, double volume,string comment,string symbol = NULL)
{int ticket = 0;
 int Error = 0;
 TradeAllowed(Error);
 if (Error != 0)
 {return(-1);
 }
 ENUM_ORDER_TYPE type;
 if (ordertype == OP_BUY)
 type = ORDER_TYPE_BUY;
 else if (ordertype == OP_SELL)
 type = ORDER_TYPE_SELL;
 else if (ordertype == OP_BUYLIMIT)
 type = ORDER_TYPE_BUY_LIMIT;
 else if (ordertype == OP_BUYSTOP)
 type = ORDER_TYPE_BUY_STOP;
 else if (ordertype == OP_SELLLIMIT)
 type = ORDER_TYPE_SELL_LIMIT;
 else type = ORDER_TYPE_SELL_STOP;
 
 if(!CheckStopLoss_Takeprofit(type,price,sl,tp))
   {Print("The StopLoss or TakeProfit level is incorrect! Unable to place trade");
    return -1;
   }
  while (ticket <= 0)
  {ticket = OrderSend(symbol,ordertype,volume,price,MaxSlippage,sl,tp,comment,MagicNumber);
   int error = GetLastError();
   bool res = Fun_Error(error);
   if ( res == true) 
   {if (ordertype == OP_BUY) price = Ask;
    else if (ordertype == OP_SELL) price = Bid;
    continue;
   }
   else if (res == false) break;
  }
  return (ticket);
}
void Trade::CloseAllSymbolEATrades(string reason) //Close all trades placed by the EA
{int ordtotal= OrdersTotal();
 for(int i=ordtotal-1;i>=0;i--)
   {if (OrderSelect(i,SELECT_BY_POS))
    {if (OrderSymbol() == _Symbol && OrderMagicNumber() == MagicNumber)
     {if (OrderType() <2)
      CloseOrder(OrderTicket(),OrderLots(),OrderClosePrice(),reason);
      else if (OrderType() >= 2)
      {bool res = OrderDelete(OrderTicket());
      if (!res)
      {int error = GetLastError();
       if (Fun_Error(error)) continue;
      }
      }
     }
    }
    
   }
}
void Trade::CloseTrades(int type, string reason) //Close trades of a particular type placed by the EA
{int ordtotal= OrdersTotal();
 for(int i=ordtotal-1;i>=0;i--)
   {if (OrderSelect(i,SELECT_BY_POS))
    {if (OrderSymbol() == _Symbol && OrderMagicNumber() == MagicNumber && OrderType() == type)
     {if (type <2)
      CloseOrder(OrderTicket(),OrderLots(),OrderClosePrice(),reason);
      else if (type >= 2)
      {bool res = OrderDelete(OrderTicket());
      if (!res)
      {int error = GetLastError();
       if (Fun_Error(error)) 
       {i++;
        continue;
       }
      }
      }
     }
    }
    
   }
}
void Trade::CloseTrades(int type, string reason, int exemption) //Close trades of a particular type placed by the EA
{int ordtotal= OrdersTotal();
 for(int i=ordtotal-1;i>=0;i--)
   {if (OrderSelect(i,SELECT_BY_POS))
    {if (OrderSymbol() == _Symbol && OrderMagicNumber() == MagicNumber && OrderType() == type)
     {if (OrderTicket() == exemption) continue;
      if (type <2)
      CloseOrder(OrderTicket(),OrderLots(),OrderClosePrice(),reason);
      else if (type >= 2)
      {bool res = OrderDelete(OrderTicket());
      if (!res)
      {int error = GetLastError();
       if (Fun_Error(error)) 
       {i++;
        continue;
       }
      }
      }
     }
    }
    
   }
}